django/wildfire/urls.py
from django.conf.urls.defaults import patterns, include, url
from django.conf import settings
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.contrib import admin
admin.autodiscover()

urlpatterns = patterns('',
    url(r'^$', 'ignite.views.requestFire', name='home'),
    url(r'^regData/$', 'ignite.views.regData'),
    url(r'^viewRequests/(?P<user_id>\d+)/$', 'ignite.views.viewRequests'),
    url(r'^viewKMZ/(?P<kmz_id>\d+)/$', 'ignite.views.viewKMZ'),
    url(r'^viewKMZ/(?P<kmz_id>\d+)/renewTimestamp/$', 'ignite.views.renewTimestamp'),
    url(r'^accounts/', include('registration.urls')),
    url(r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', include(admin.site.urls)),
)

if settings.DEBUG:
    urlpatterns += patterns('',
        url(r'^media/(?P<path>.*)$', 'django.views.static.serve', {
            'document_root': settings.MEDIA_ROOT,
        })
    )

urlpatterns += staticfiles_urlpatterns()

django/wildfire/ignite/models.py
import datetime

from django.conf import settings
from django.db import models
from django import forms
from django.contrib.auth.models import User
from ignite.paramikoSSH import email_user_error

class LocationManager(models.Manager):

    def handleBrokenRequest(self):
        """
        See's if something went wrong in the request process.
        If something goes wrong, it will notify the user
        """
        for location in self.all():
            if location.request_timeout():
                email_user_error(location)
                location.delete()

    def handleExpiredRequest(self):
        """
        Removes the request if it has expired
        """
        for location in self.all():
            if location.location_expired():
                location.delete()


class Location(models.Model):
    """
    Profile that stores the location.
    """

    user = models.ForeignKey(User)
    title = models.CharField(max_length=30)

    objects = LocationManager()

    map_proj_choices = (('la', 'lambert'),
                        ('me', 'mercator'),
                        ('po', 'polar'),
                        ('rl', 'rotated_ll'),
                        ('ll', 'lat-lon'))

    centerLat    = models.FloatField()
    centerLon    = models.FloatField()
    ignLat       = models.FloatField()
    ignLon       = models.FloatField()
    ignTime      = models.DateTimeField("Ignition Time")
    dx           = models.FloatField(default=100)
    dy           = models.FloatField(default=100)
    nx           = models.IntegerField(default=40)
    ny           = models.IntegerField(default=41)
    runTime      = models.FloatField("Run Time", default=1)
    spinupTime   = models.FloatField("Spinup Time", default=.001)
    map_proj     = models.CharField("Map Projection", max_length=2, choices=map_proj_choices, default='la')
    ign_radius   = models.FloatField("Ignition Radius", default=10)
    is_complete  = models.BooleanField("Completed", default=False, editable=False)
    timestamp    = models.DateTimeField("Time Stamp", auto_now=True)

    def attrs(self):
        """
        Iterates through the keys so you know what is
        within the particular model.
        """
        for attr, value in self.__dict__.iteritems():
            yield attr, value

    def request_timeout(self):
        """
        See's if the request has been taking too long.
        """
        expiration = datetime.timedelta(hours=settings.WRF_REQUEST_TIMEOUT_HOURS)
        return (self.timestamp + expiration <= datetime.datetime.today())

    def location_expired(self):
        """
        Looks at if location has exceeded max number of days
        """
        expiration = datetime.timedelta(days=settings.WRF_REQUEST_EXPIRE_DAYS)
        return (self.timestamp + expiration <= datetime.datetime.today())

    def renew_timestamp(self):
        """
        Renews the timestamp so it doesn't expire another 7 days
        """
        self.timestamp = datetime.datetime.today()
        self.save()

    def __unicode__(self):
        return str(self.pk) + ' - ' + self.title

class LocationForm(forms.ModelForm):
    """
    Form that will be generated when requested by the user
    """
    user = forms.ModelChoiceField(widget=forms.HiddenInput(), queryset=User.objects.all())
    centerLat   = forms.FloatField(widget=forms.HiddenInput())
    centerLon   = forms.FloatField(widget=forms.HiddenInput())
    ignLat      = forms.FloatField(widget=forms.HiddenInput())
    ignLon      = forms.FloatField(widget=forms.HiddenInput())
    title       = forms.CharField(help_text="Used for reference")
    ignTime     = forms.DateTimeField(initial='10/5/2011 5:00:00', label="Ignition Time")

    class Meta:
        model = Location

django/wildfire/ignite/views.py
import thread, datetime

from django.contrib.auth.decorators import login_required
from django.shortcuts import render_to_response
from django.http import HttpResponse, HttpResponseRedirect
from django.template import RequestContext
from django.conf import settings

from ignite.models import LocationForm, Location
from paramikoSSH import make_WRF_request


##########################################################
##########################################################
#
### HTTP RESPONSE CODES
#
# 200 - Success
#
##########################################################
##########################################################

# Calls the template that connects to Google Earth/Maps
@login_required
def requestFire(request):
    locations = Location.objects.filter(user=request.user)
    return render_to_response('ignite/request_fire_simulation.html', { 'locations': locations }, context_instance=RequestContext(request))

# This is the AJAX Call when clicking on the map that will show the request
# information.
@login_required
def regData(request):
    if request.method == 'POST':
        form = LocationForm(request.POST)

        if form.is_valid():

            data = form.save()

            # Starts the Paramiko request of making the files on the Server side
            if settings.DEBUG_PARAMIKO:
                make_WRF_request(data.pk, data)
            else:
                thread.start_new_thread(make_WRF_request, (data.pk, data))

            # This will go into the thread upon creation
            return render_to_response('ignite/requestConfirmation.html', { 'location': data }, context_instance=RequestContext(request))

    else:
        form = LocationForm(initial={'user':request.user.pk})
    
    return render_to_response('ignite/regData.html', { 'form': form, }, context_instance=RequestContext(request))


# Views all of the requests that the user has made
def viewRequests(request, user_id):
    locations = Location.objects.filter(user=user_id).order_by('title')
    return render_to_response('ignite/viewRequests.html', { 'locations': locations }, context_instance=RequestContext(request))

# Views KMZ that was put in
def viewKMZ(request, kmz_id):
    location = Location.objects.get(pk=kmz_id)
    expire_date = location.timestamp + datetime.timedelta(days=settings.WRF_REQUEST_EXPIRE_DAYS)
    return render_to_response('ignite/viewKMZ.html', { 'location': location, 'expire_date': expire_date }, context_instance=RequestContext(request))

# Renews the Timestamp to this current time
def renewTimestamp(request, kmz_id):
    Location.objects.get(pk=kmz_id).renew_timestamp()
    return HttpResponseRedirect("/viewKMZ/%s/" % kmz_id)

django/wildfire/templates/ignite/regData.html
<head>

    {% include 'backend/base.html' %}

    <script type="text/javascript">
        $(document).ready(function(){
            $("#id_title").focus();
            $('#advanced_search_field').hide();

            $("#advanced_search").click(function(){
                if($("#advanced_search_field").is(":hidden")){
                    $("#advanced_search_field").slideDown();
                }
                else{
                    $("#advanced_search_field").slideUp();
                }
                return false;
            });
        })
    </script>
</head>
<h1>Register Data</h1>
<form id="request_WRF" action="" method="post">{% csrf_token %}
    {% for hidden in form.hidden_fields %}
        {{ hidden }}
    {% endfor %}

    {{ form.title.errors }}
    {{ form.title.label }}:{{ form.title }}{{ form.title.help_text }}<br/>

    {{ form.ignTime.errors }}
    {{ form.ignTime.label }}:{{ form.ignTime }}<br/>

    <div id="advanced_search_field">
        {% for field in form.visible_fields %}
            {% if field.label != "Title" and field.label != "Ignition Time" %}
                {{ field.errors }}
                {{ field.label_tag }}:{{ field }}{{ field.help_text }}<br/>
            {% endif %}
        {% endfor %}
    </div>
    <br/>
    <a href="#" id="advanced_search">Advanced Search</a>
    <!-- DEBUGGING PURPOSES - <input type="submit" value="Submit"/> -->
</form>

django/wildfire/templates/ignite/requestConfirmation.html
{% extends 'template.html' %}

{% block content %}
    Thank you for your request.  Depending on the parameters chosen,
    this simulation can take up to 24 hours to build.  We will inform
    you by email when your simulation is complete.
    <div id="location">
        <input type="hidden" id="pk" value="{{ location.pk }}" />
    </div>
{% endblock %}

django/wildfire/templates/ignite/request_fire_simulation.html
{% extends 'template.html' %}

{% block title %}WRF Simulation Request{% endblock %}
{% block head %}
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
    <style type="text/css">
        #layout { position: absolute; bottom: 0px; width: 100%; height: 85%; border-top-style: solid; }
        #map_canvas { position: absolute; bottom:0px; left: 300px; right:0px; width: 100%; height: 100%; border-left-style: solid; }
        #pastRequests { position: absolute; bottom: 0px; width: 300px; height: 100%;}
        #logout {position:absolute; right:0px; top:0px;}
    </style>
    <script type="text/javascript">
        var map;

        function updatePastRequests(){
            var url = '/viewRequests/{{ user.pk }}/';

            $.ajax({
                url:url,
                ifModified:true,
                success:function(html){
                    $("#pastRequests").html(html);
                },
                error:function(){
                    $("#pastRequests").html("<a href='" + url + "'>View Past Requests</a>");
                }
            });

            // Delays 5 seconds before updating content again
            setTimeout(updatePastRequests, 5000);
        }

        // Adds the markers to the map for all of the latlngs that the user has already requested
        function addLatLngs_to_map(){
            var lat = 0;
            var lng = 0;
            var pk = 0;
            var title = "";
            var link = "";
            var latlng;
            var marker;

            // Grabs all the inputs and places it into data
            $(".latlng").each(function(i){
                lat = $(this).find("#lat").val();
                lng = $(this).find("#lng").val();
                pk  = $(this).find("#pk").val();

                title = $(this).find("#title").val();
                latlng = new google.maps.LatLng(lat, lng);
                link = '/viewKMZ/' + pk + "/";

                marker = new google.maps.Marker({
                    position: latlng,
                    title: title,
                    url: link
                });
                marker.setMap(map);

                // Makes Marker Clickable
                google.maps.event.addListener(marker, 'click', function(){
                    window.location.href = this.url;
                });
            });

        }

        function initialize() {

            var latlng = new google.maps.LatLng(40.07160929510595, -105.9405756939366);
            var myOptions = {
                zoom      : 10,
                center    : latlng,
                mapTypeId : google.maps.MapTypeId.HYBRID
            };
            map = new google.maps.Map(document.getElementById("map_canvas"),
                    myOptions);

            $(document).ajaxSend(function(event, xhr, settings) {
                function getCookie(name) {
                    var cookieValue = null;
                    if (document.cookie && document.cookie != '') {
                        var cookies = document.cookie.split(';');
                        for (var i = 0; i < cookies.length; i++) {
                            var cookie = jQuery.trim(cookies[i]);
                            // Does this cookie string begin with the name we want?
                            if (cookie.substring(0, name.length + 1) == (name + '=')) {
                                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                                break;
                            }
                        }
                    }
                    return cookieValue;
                }
                function sameOrigin(url) {
                    // url could be relative or scheme relative or absolute
                    var host      = document.location.host; // host + port
                    var protocol  = document.location.protocol;
                    var sr_origin = '//' + host;
                    var origin    = protocol + sr_origin;
                    // Allow absolute or scheme relative URLs to same origin
                    return (url == origin || url.slice(0, origin.length + 1) == origin + '/') ||
                            (url == sr_origin || url.slice(0, sr_origin.length + 1) == sr_origin + '/') ||
                        // or any other URL that isn't scheme relative or absolute i.e relative.
                            !(/^(\/\/|http:|https:).*/.test(url));
                }
                function safeMethod(method) {
                    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
                }

                if (!safeMethod(settings.type) && sameOrigin(settings.url)) {
                    xhr.setRequestHeader("X-CSRFToken", getCookie('csrftoken'));
                }
            });

            google.maps.event.addListener(map, 'click', function(event){
                var bounds    = map.getBounds();
                var southWest = bounds.getSouthWest();
                var northEast = bounds.getNorthEast();
                var dialog    = $("#dialog");

                $.ajax({
                    url: "regData/",
                    success: function(html){
                        dialog.html(html);
                        dialog.find("#id_centerLat").val((southWest.lat()+northEast.lat())/2);
                        dialog.find("#id_centerLon").val((southWest.lng()+northEast.lng())/2);
                        dialog.find("#id_ignLat").val(event.latLng.lat());
                        dialog.find("#id_ignLon").val(event.latLng.lng());

                    },
                    error: function(html){
                        alert("Error Code: " + html);
                    }
                });

                dialog.dialog({
                    "title":"Simulator Input",
                    "width":450,
                    "buttons":{
                        "Submit":function(){
                            var data={};

                            // Grabs all the inputs and places it into data
                            dialog.find(':input')
                                .each(function(i){
                                        data[this.name] = this.value;
                                    });
                            $.ajax({
                                type:'POST',
                                url:'/regData/',
                                data: data,
                                success:function(html){
                                    // Used to compare to see if data valid
                                    var title = $("#dialog").find("title").html();

                                    $("#dialog").html(html);

                                    if($("#dialog").find("title").html() != title){
                                        var pk = $("#location").find("#pk").val();
                                        var link = "/viewKMZ/" + pk + "/";
                                        var marker = new google.maps.Marker({
                                            position: event.latLng,
                                            title: data['title'],
                                            url: link
                                        });
                                        marker.setMap(map);

                                        // Makes Marker Clickable
                                        google.maps.event.addListener(marker, 'click', function(){
                                            window.location.href = this.url;
                                        });

                                        $("#dialog").dialog('option', 'buttons', {'Close':function(){$("#dialog").dialog("close")}});
                                    }
                                },
                                error:function(){
                                    alert("ERROR:  CSRF Token might be incorrect.");
                                }
                            });
                        },
                        "Cancel":function(){
                            $("#dialog").dialog("close");
                        }
                    }
                });
            });

            // Updates all of the past requests onto the map
            updatePastRequests();
            addLatLngs_to_map();
        }

    </script>
{% endblock %}
{% block onload %}initialize(){% endblock %}
{% block content %}
    Click on a position on the map to start a wildfire simulation.
    <div id="layout">
        <div id="pastRequests">Loading</div>
        <div id="map_canvas"></div>
    </div>
    <div id="logout">{{ user.email }} (<a href="/accounts/logout/">Logout</a>)</div>
    <div id="dialog"></div>

    {% for location in locations %}
        <div class="latlng">
            <input type="hidden" id="pk" value="{{ location.pk }}" />
            <input type="hidden" id="lat" value="{{ location.ignLat }}" />
            <input type="hidden" id="lng" value="{{ location.ignLon }}" />
            <input type="hidden" id="title" value="{{ location.title }}" />
        </div>
    {% endfor %}
{% endblock %}

django/wildfire/templates/ignite/viewKMZ.html
{% extends 'template.html' %}

{% block title %}WRF Simulation Request{% endblock %}
{% block head %}
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
    <script type="text/javascript" src="{{ STATIC_URL }}js/KML_Logic.js"></script>
    <style type="text/css">
        #control{
            position: absolute;
            top:      50px;
            left:     50px;
            width:    200px;
            height:   100px;
            z-index:  100;
        }
        #layout { position: absolute; bottom: 0px; width: 100%; height: 100%; }
        #map_canvas { position: absolute; bottom:0px; left: 300px; right:0px; width: 100%; height: 100%; border-left-style: solid; }
        #locationInfo { position: absolute; width: 300px; top: 150px; }
    </style>
    <script type="text/javascript">
        var map;

        function initialize() {

            // Grabs all the inputs and places it into data
            var centerLat = $("#location").find("#centerLat").val();
            var centerLon = $("#location").find("#centerLon").val();

            var latlng = new google.maps.LatLng(centerLat, centerLon);

            var myOptions = {
                zoom      : 10,
                center    : latlng,
                mapTypeId : google.maps.MapTypeId.HYBRID
            };
            map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);

            // Starts the animation listener.  CALL THIS ONLY ONCE when initializing
            startAnimation(500);

            var url = "/media/" + $("#location").find("#id").val() + "/";

            //Initializes the animation
            initiateFolderContents(event.latLng, url, "doc.kml", 0);
        }

    </script>
{% endblock %}
{% block onload %}initialize(){% endblock %}
{% block content %}
    {% if location.is_complete %}
        <div id="layout">
            <div id="locationInfo">
                <h1>{{ location.title }}</h1>
                Latitude: {{ location.ignLat }}<br/>
                Longitude: {{ location.ignLon }}<br/>
                Ignition Time: {{ location.ignTime }}<br/>
                Run Time: {{ location.runTime }}<br/>
                Spinup Time: {{ location.spinupTime }}<br/>
                Ignition Radius: {{ location.ign_radius }}<br/>
                Expires: <font color="red">{{ expire_date }}</font><br/>
                <a href="renewTimestamp/">Renew Time Stamp?</a><br/>

            </div>
            <div id="map_canvas"></div>
        </div>
        <div id="control">
            <div id="slider"></div>
            <br/>
            <button class="ui-state-default ui-corner-all" id="play-button"><span class="ui-icon ui-icon-play"></span></button>
            <button class="ui-state-default ui-corner-all" id="pause-button"><span class="ui-icon ui-icon-pause"></span></button>
            <button class="ui-state-default ui-corner-all" id="stop-button"><span class="ui-icon ui-icon-stop"></span></button>
        </div>
        <div id="location">
            <input type="hidden" id="centerLat" value="{{ location.centerLat }}" />
            <input type="hidden" id="centerLon" value="{{ location.centerLon }}" />
            <input type="hidden" id="id" value="{{ location.pk }}" />
        </div>
    {% else %}
        Your request is still in the process of being completed.  Please check back later.<br/>
        <a href="/">Home</a>
    {% endif %}
{% endblock %}

django/wildfire/templates/ignite/viewRequests.html
<h1>Request History</h1>
{% if locations %}
    {% for loc in locations %}
        <p>
            {% if loc.is_complete %}
                <a href="/viewKMZ/{{ loc.pk }}/">'{{ loc.title }}'</a>
                <font color="green">complete.</font>
            {% else %}
                '{{ loc.title }}'
                <font color="red">is still being generated.</font>
            {% endif %}
        </p>
    {% endfor %}
{% else %}
    You have not made any requests.
{% endif %}